package com.gic.haoban.manage.service.service.out.impl;


import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.service.service.*;
import com.gic.wechat.api.dto.qywx.QywxIinkExternalMessageDTO;
import com.gic.wechat.api.dto.qywx.QywxImageExternalMessageDTO;
import com.gic.wechat.api.dto.qywx.QywxTextExternalMessageDTO;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.MD5Utils;
import com.gic.commons.util.Md5Util;
import com.gic.commons.util.StringUtil;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.contacts.manage.api.dto.SearchDataDTO;
import com.gic.haoban.manage.api.service.DepartmentApiService;
import com.gic.haoban.manage.api.service.MaterialApiService;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.api.service.StaffDepartmentRelatedApiService;
import com.gic.haoban.manage.api.service.WxEnterpriseApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.entity.MemberUnionidRelated;
import com.gic.haoban.manage.service.entity.TabHaobanClerkMainStoreRelated;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterpriseRelated;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberService;
import com.gic.redis.data.anno.RedisLock;
import com.gic.redis.data.util.RedisUtil;
import com.gic.search.engine.api.constant.MemberDataEnum;
import com.gic.search.engine.api.constant.OperateEnum;
import com.gic.search.engine.api.dto.ESResponseQueryBatch;
import com.gic.search.engine.api.dto.ESResponseQuerySingle;
import com.gic.search.engine.api.dto.dynamic.DynamicSearchDTO;
import com.gic.search.engine.api.filter.NewNodeAddUtil;
import com.gic.search.engine.api.service.dynamic.ESDataDynamicOperationApiService;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService{
	private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
	@Autowired
	private MemberUnionRelatedService memberUnionRelatedService;
	@Autowired
	private StaffService staffService;
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;
	@Autowired
	private MemberService memberService;
	@Autowired
	private WxEnterpriseRelatedService wxEnterpriseRelatedService;
	@Autowired
	private WxEnterpriseService wxEnterpriseService;
	
	private static final String SELF_APP = "selfSuiteId";
	
	@Autowired
	private MemberOpenCardBusinessService memberOpenCardBusinessService;
	
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private DepartmentApiService departmentApiService;

	@Autowired
	private MemberUnionidRelatedMapper memberUnionidRelatedMapper;
	
	@Autowired
	private StaffDepartmentRelatedService staffDepartmentRelatedService;
	@Autowired
	private ESDataDynamicOperationApiService eSDataDynamicOperationApiService;
	@Autowired
	private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
	@Autowired
	private StoreService storeService;
	@Autowired
	private Config config;
	@Autowired
	private QywxSuiteApiService qywxSuiteApiService;
	@Autowired
	private MaterialApiService materialApiService;

	@Autowired
	private SecretSettingService secretSettingService;
	
	@Autowired
	private StaffClerkRelationService staffClerkRelationService;
	
	@Override
	public List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId) {
		List<MemberUnionidRelated> list = memberUnionidRelatedMapper.listByExTernalUseridAndWxUserId(externalUserid, wxUserId);
		List<MemberStoreDTO> result = new ArrayList<>();
		if(CollectionUtil.isEmpty(list)){
			return null;
		}
		//1、查该staff的门店id
		List<TabHaobanStaffDepartmentRelated> relatedIds = staffDepartmentRelatedService.listByWxUserId(wxUserId);
		if(CollectionUtil.isEmpty(relatedIds)){
			log.info("staff关联部门不存在1");
			return null;
		}
		List<String> departmentIds = relatedIds.stream().map(s->s.getDepartmentId()).collect(Collectors.toList());
		if(CollectionUtil.isEmpty(departmentIds)){
			log.info("staff部门不存在1");
			return null;
		}
		List<DepartmentDTO> stores  = departmentApiService.listByDepartmentIds(departmentIds, 1);
		if(CollectionUtil.isEmpty(stores)){
			log.info("staff关联门店不存在1");
			return null;
		}
		List<String> storeIds = stores.stream().filter(s->(s.getRelatedId()!=null || "".equals(s.getRelatedId()))).map(s->s.getRelatedId()).collect(Collectors.toList());
		if(CollectionUtil.isEmpty(storeIds)){
			log.info("staff关联门店不存在2");
			return null;
		}
		//2、获取member的storeId
		for(MemberUnionidRelated tab : list){
			String memberId = tab.getMemberId();
			if(StringUtils.isEmpty(memberId)){
				continue ;
			}
			String gicEnterpriseId = tab.getEnterpriseId();
			JSONObject searchJson = new JSONObject();
			searchJson = NewNodeAddUtil.addNewNodeForAnd(MemberDataEnum.member_memberId.getCode(), OperateEnum.OPERATE_EQ.getValue(), memberId,searchJson);
			DynamicSearchDTO dynamicSearchDTO = new DynamicSearchDTO();
			dynamicSearchDTO.setEnterpriseId(gicEnterpriseId);
			dynamicSearchDTO.setColumnCategoryCode("member");
			dynamicSearchDTO.setSearchJson(searchJson);
			dynamicSearchDTO.setBegin(0);
			dynamicSearchDTO.setRecordNumber(1);
			log.info("gicEnterpriseId=========>{},searchJson=========={}",gicEnterpriseId,searchJson);
			ESResponseQueryBatch responseQuery = eSDataDynamicOperationApiService.queryDataBatch(dynamicSearchDTO, false, null);
			if(null == responseQuery){
				log.info("会员不存在1");
				continue;
			}
			List<JSONObject> res = responseQuery.getRes();			
			if(CollectionUtil.isEmpty(res)){
				log.info("会员不存在2");
				continue;
			}
			String storeId = "";
			for (JSONObject jsonObject : res) {
				 storeId = jsonObject.get("storeId") == null?"":jsonObject.get("storeId").toString();
			}
			if(StringUtils.isEmpty(storeId)){
				log.info("会员门店不存在");
				continue;
			}
			String[] memberStoreIds =storeId.split(" "); 
			List<String> memberStoreIdList = Arrays.asList(memberStoreIds);
			if(CollectionUtil.isEmpty(memberStoreIdList)){
				log.info("会员门店不存在");
				continue;
			}
			log.info("memberStoreIdList===============>{}",JSONObject.toJSONString(memberStoreIdList));
			log.info("storeIds===============>{}",JSONObject.toJSONString(storeIds));
			//取交集(解决不支持的报错现象)
			List list3= new ArrayList(memberStoreIdList);
			List list4= new ArrayList(storeIds);
			list3.retainAll(list4);
			if(CollectionUtil.isEmpty(list3)){
				continue;
			}else{
				for(Object resultStoreId : list3){
					MemberStoreDTO dto = new MemberStoreDTO();
					dto.setMemberId(memberId);
					dto.setStoreId(resultStoreId.toString());
					result.add(dto);
				}
				
			}
		}
		return result;
	}
	@Override
	public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),unionid);
		return memberUnionRelatedService.getByUnionId(staff.getWxUserId(),unionid);
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		log.info("【新增外部联系人回调】dto={}",JSON.toJSONString(dto));
		String corpId = dto.getCorpid();
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
		if(wxEnterprise == null){
			return "";
		}

		List<TabHaobanWxEnterpriseRelated> list = wxEnterpriseRelatedService.getByWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
		String suiteid = dto.getSuiteid();		
		String unionIdJson = "";
		if(SELF_APP.equals(suiteid)){
			SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterprise.getWxEnterpriseId(), SecretTypeEnum.CONTACT_CUSTOMER.getVal());
			if (null == secretSetting) {
				log.info("没有配置secret");
				return "";
			}
			unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), secretSetting.getSecretVal(), dto.getExternalUserid());
		}else{
			unionIdJson = qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		}
		String userId1 = dto.getWxUserId();
		
		log.info("【新增外部联系人回调】unionIdJson={}",JSON.toJSONString(unionIdJson));
		String unionId = "";
		String name = "";
		String follow_user = "";
		String createTime  = "";
		String userId = "";
		String avatar = "";
		String relaName = "";
		if(StringUtils.isNotBlank(unionIdJson)){
			JSONObject jo = JSON.parseObject(unionIdJson);
			String external_contact  = jo.getString("external_contact");
			if(StringUtils.isNotBlank(external_contact)){
				JSONObject jt = JSON.parseObject(external_contact);
				unionId = jt.getString("unionid");
				name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				avatar = jt.getString("avatar");
			}
			
			follow_user = jo.getString("follow_user");
			if(StringUtils.isNotBlank(follow_user)){
				JSONArray j = JSON.parseArray(follow_user);
				for (Object object : j) {
					String followJson = JSON.toJSONString(object);
					JSONObject follow = JSON.parseObject(followJson);
					userId = follow.getString("userid");
					if(userId.equals(userId1)){
						createTime = follow.getString("createtime");
					}
				}
			}
		}
		
		TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId1, wxEnterprise.getWxEnterpriseId());
		if(staff == null){
			return "";
		}
		
		List<String> enterpriseIdList = list.stream().map(s->s.getEnterpriseId()).collect(Collectors.toList());
		List<StaffClerkRelationDTO> staffRelationList = staffClerkRelationService.listBindCodeByStaffId(enterpriseIdList, staff.getStaffId());
		if(staffRelationList == null || staffRelationList.isEmpty()){
			log.info("【新增外部联系人】未绑定");
			return "";
		}
		TabHaobanClerkMainStoreRelated r = clerkMainStoreRelatedService.selectByWxEnterpriseIdAndStoreId(staff.getStaffId(),wxEnterprise.getWxEnterpriseId());
		StoreDTO mainStore = null;
		for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
			if(r != null){
				mainStore = storeService.getStore(r.getStoreId());
				if(mainStore != null){
					if(!tabHaobanWxEnterpriseRelated.getEnterpriseId().equals(mainStore.getEnterpriseId())){
						continue;
					}
				}
			}
			String key = "external" + tabHaobanWxEnterpriseRelated.getEnterpriseId() + "_"+ userId1 + "_" + name + "_" + createTime;
			RedisUtil.lock(key,2l);
			dto.setWxEnterpriseId(tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
			dto.setEnterpriseId(tabHaobanWxEnterpriseRelated.getEnterpriseId());
			MemberDTO member = null;
			//TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId1, tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
			if(staff == null){
				continue;
			}
			if(SELF_APP.equals(suiteid)){
//				List<StaffDepartmentRelatedDTO> relatedList = staffDepartmentRelatedApiService.listByStaffId(staff.getStaffId());
//				log.info("【部门list】staffId={}",staff.getStaffId());
//				List<StaffDepartmentRelatedDTO> rList = new ArrayList<StaffDepartmentRelatedDTO>();
//				for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
//					DepartmentDTO depart = departmentApiService.selectById(staffDepartmentRelatedDTO.getDepartmentId());
//					log.info("【部门list】depart={},deparmentId={}",JSON.toJSONString(depart),staffDepartmentRelatedDTO.getDepartmentId());
//					if(depart != null && tabHaobanWxEnterpriseRelated != null && depart.getEnterpriseId() != null && tabHaobanWxEnterpriseRelated.getEnterpriseId() != null){
//						log.info("【部门list】enterpriseId={},enterpriseId2={}",depart.getEnterpriseId(),tabHaobanWxEnterpriseRelated.getEnterpriseId());
//						if(depart.getEnterpriseId().equals(tabHaobanWxEnterpriseRelated.getEnterpriseId())){
//							if(mainStore != null){
//								if(depart.getRelatedId().equals(mainStore.getStoreId())){
//									rList.add(staffDepartmentRelatedDTO);
//								}
//							}else{
//								rList.add(staffDepartmentRelatedDTO);
//							}
//						}
//					}
//				}
//				log.info("【部门list】rList={}",JSON.toJSONString(rList));
//				//DepartmentDTO departmentDTO =
//				String clerkCode = "";
//				if(!rList.isEmpty()){
//					for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : rList) {
//						clerkCode = staffDepartmentRelatedDTO.getClerkCode();
//						if(StringUtils.isNotBlank(clerkCode)){
//							break;
//						}
//					}
//				}
				
				String clerkCode = "";
				for (StaffClerkRelationDTO staffClerkRelationDTO : staffRelationList) {
					if(tabHaobanWxEnterpriseRelated.getEnterpriseId().equals(staffClerkRelationDTO.getEnterpriseId())){
						clerkCode = staffClerkRelationDTO.getClerkCode();
						break;
					}
				}
				ClerkDTO clerk = clerkService.getClerkByClerkCode(tabHaobanWxEnterpriseRelated.getEnterpriseId(), clerkCode);
				log.info("【新增外部联系人】clerkCode={}",clerkCode);
				if(clerk != null && StringUtils.isNotBlank(clerk.getQrcodeParam())&&StringUtils.isNotBlank(unionId)){
					log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
					 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,"",relaName,avatar,clerk.getQrcodeParam());
				}
				log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
				if(member != null){
					dto.setMemberId(member.getMemberId());
				}
			}
			dto.setSelfExternalUserid(dto.getExternalUserid());
			dto.setUnionid(unionId);
			
			dto.setExternalName(name);
			dto.setAddCreateTime(createTime);
			if(StringUtils.isBlank(unionId)){
				return "";
			}
			
			dto.setSuiteid(wxEnterprise.getWxSecretKey());
			
			MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(dto.getWxUserId(), tabHaobanWxEnterpriseRelated.getEnterpriseId(),name,createTime);
			String uuid = "";
			if(exsitDTO == null){
				uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
			}else{
				//如果是自建更新uuid
				if(SELF_APP.equals(suiteid)){
					exsitDTO.setUnionid(unionId);
					exsitDTO.setMemberId(dto.getMemberId());
				}else{
					//更新对外联系人id
					exsitDTO.setExternalUserid(dto.getExternalUserid());
				}
				memberUnionRelatedService.update(exsitDTO);
				uuid = exsitDTO.getMemberUnionidRelatedId();
			}
		}
		
//		if(SELF_APP.equals(suiteid)){
//			MemberDTO member = null;
//			for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
//				TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
//				if(staff == null){
//					continue;
//				}
//				List<StaffDepartmentRelatedDTO> relatedList = staffDepartmentRelatedApiService.listByStaffId(staff.getStaffId());
//				String clerkCode = "";
//				if(!relatedList.isEmpty()){
//					for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
//						clerkCode = staffDepartmentRelatedDTO.getClerkCode();
//						if(StringUtils.isNotBlank(clerkCode)){
//							break;
//						}
//					}
//				}
//				ClerkDTO clerk = clerkService.getClerkByClerkCode(tabHaobanWxEnterpriseRelated.getEnterpriseId(), clerkCode);
//				if(clerk != null){
//					log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
//					 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,null,name,avatar,clerk.getQrcodeParam());
//				}
//				log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
//				 //member = memberService.getMemberByUnionid(unionId, tabHaobanWxEnterpriseRelated.getEnterpriseId());
////				 if(member != null){
////					 break;
////				 }
//			}
//			if(member != null){
//				dto.setMemberId(member.getMemberId());
//			}
//			dto.setSelfExternalUserid(dto.getExternalUserid());
//			dto.setUnionid(unionId);
//		}
//		
//		dto.setExternalName(name);
//		dto.setAddCreateTime(createTime);
//		if(StringUtils.isBlank(unionId)){
//			return "";
//		}
//		
//		dto.setWxEnterpriseId(wxEnterprise.getWxEnterpriseId());
//		dto.setSuiteid(wxEnterprise.getWxSecretKey());
//		
//		MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(dto.getWxUserId(), wxEnterprise.getWxEnterpriseId(),name,createTime);
//		String uuid = "";
//		if(exsitDTO == null){
//			uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
//		}else{
//			//如果是自建更新uuid
//			if(SELF_APP.equals(suiteid)){
//				exsitDTO.setUnionid(unionId);
//				exsitDTO.setMemberId(dto.getMemberId());
//			}else{
//				//更新对外联系人id
//				exsitDTO.setExternalUserid(dto.getExternalUserid());
//			}
//			memberUnionRelatedService.update(exsitDTO);
//			uuid = exsitDTO.getMemberUnionidRelatedId();
//		}
		return "";
	}
	
	
	@Override
	public String add(String wxEnterpriseId,String selfExternalUserId,String userId1) {
		WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		if(wxEnterprise == null){
			return "";
		}
		List<TabHaobanWxEnterpriseRelated> list = wxEnterpriseRelatedService.getByWxEnterpriseId(wxEnterprise.getWxEnterpriseId());

		SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
		if (null == secretSetting) {
			log.info("没有配置secret");
			return "";
		}
		String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), selfExternalUserId);
		
		log.info("【新增外部联系人回调】unionIdJson={}",JSON.toJSONString(unionIdJson));
		String unionId = "";
		String name = "";
		String follow_user = "";
		String createTime  = "";
		String userId = "";
		String avatar = "";
		String relaName = "";
		if(StringUtils.isNotBlank(unionIdJson)){
			JSONObject jo = JSON.parseObject(unionIdJson);
			String external_contact  = jo.getString("external_contact");
			if(StringUtils.isNotBlank(external_contact)){
				JSONObject jt = JSON.parseObject(external_contact);
				unionId = jt.getString("unionid");
				name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
				avatar = jt.getString("avatar");
			}
			
			follow_user = jo.getString("follow_user");
			if(StringUtils.isNotBlank(follow_user)){
				JSONArray j = JSON.parseArray(follow_user);
				for (Object object : j) {
					String followJson = JSON.toJSONString(object);
					JSONObject follow = JSON.parseObject(followJson);
					userId = follow.getString("userid");
					if(userId.equals(userId1)){
						createTime = follow.getString("createtime");
					}
				}
			}
		}
		
		log.info("新增外部联系人】corpid={},suiteId={},userId1={}",wxEnterprise.getCorpid(),config.getWxSuiteid(),userId1);
		String wxRes = qywxUserApiService.listExternalUserid(wxEnterprise.getCorpid(), config.getWxSuiteid(), userId1);
		MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
		String externalUserId = "";
		log.info("【新增外部联系人】wxRes={}",wxRes);
		if(StringUtils.isNotBlank(wxRes)){
			JSONArray jsonArr = JSON.parseArray(wxRes);
			String wxName = "";
			for (Object externalUserid : jsonArr) {
				String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserid.toString());
				
				if(StringUtils.isNotBlank(uJ)){
					JSONObject jo = JSON.parseObject(uJ);
					String external_contact  = jo.getString("external_contact");
					String uj_follow_user = jo.getString("follow_user");
					if(StringUtils.isNotBlank(external_contact)){
						JSONObject jt = JSON.parseObject(external_contact);
						externalUserId = jt.getString("external_userid");
						wxName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
					}
					if(StringUtils.isNotBlank(uj_follow_user)){
						JSONArray j = JSON.parseArray(uj_follow_user);
						String uj_userId = "";
						for (Object object : j) {
							String followJson = JSON.toJSONString(object);
							JSONObject follow = JSON.parseObject(followJson);
							uj_userId = follow.getString("userid");
							log.info("【新增外部联系人】createTime={},name={},followCreateTime={},wxName={}",createTime,name,follow.getString("createtime"),wxName);
							if(uj_userId.equals(userId1) && createTime.equals(follow.getString("createtime")) && name.equals(wxName)){
								dto.setExternalUserid(externalUserId);
								break;
							}
						}
					}
				}
			}
		}
		
		TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId1, wxEnterprise.getWxEnterpriseId());
		if(staff == null){
			return "";
		}
		TabHaobanClerkMainStoreRelated r = clerkMainStoreRelatedService.selectByWxEnterpriseIdAndStoreId(staff.getStaffId(),wxEnterprise.getWxEnterpriseId());
		StoreDTO mainStore = null;
		
		List<String> enterpriseIdList = list.stream().map(s->s.getEnterpriseId()).collect(Collectors.toList());
		List<StaffClerkRelationDTO> staffRelationList = staffClerkRelationService.listBindCodeByStaffId(enterpriseIdList, staff.getStaffId());
		if(staffRelationList == null || staffRelationList.isEmpty()){
			log.info("【新增外部联系人】未绑定");
			return "";
		}
		
		
		for (TabHaobanWxEnterpriseRelated tabHaobanWxEnterpriseRelated : list) {
			if(r != null){
				mainStore = storeService.getStore(r.getStoreId());
				if(mainStore != null){
					if(!tabHaobanWxEnterpriseRelated.getEnterpriseId().equals(mainStore.getEnterpriseId())){
						continue;
					}
				}
			}
			String key = "external" + tabHaobanWxEnterpriseRelated.getEnterpriseId() + "_"+ userId1 + "_" + name + "_" + createTime;
			RedisUtil.lock(key,2l);
			dto.setWxEnterpriseId(tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
			dto.setEnterpriseId(tabHaobanWxEnterpriseRelated.getEnterpriseId());
			MemberDTO member = null;
			//TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId1, tabHaobanWxEnterpriseRelated.getWxEnterpriseId());
			if(staff == null){
				continue;
			}
//			List<StaffDepartmentRelatedDTO> relatedList = staffDepartmentRelatedApiService.listByStaffId(staff.getStaffId());
//			log.info("【部门list】staffId={}",staff.getStaffId());
//			List<StaffDepartmentRelatedDTO> rList = new ArrayList<StaffDepartmentRelatedDTO>();
//			for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
//				DepartmentDTO depart = departmentApiService.selectById(staffDepartmentRelatedDTO.getDepartmentId());
//				log.info("【部门list】depart={},deparmentId={}",JSON.toJSONString(depart),staffDepartmentRelatedDTO.getDepartmentId());
//				if(depart != null && tabHaobanWxEnterpriseRelated != null && depart.getEnterpriseId() != null && tabHaobanWxEnterpriseRelated.getEnterpriseId() != null){
//					log.info("【部门list】enterpriseId={},enterpriseId2={}",depart.getEnterpriseId(),tabHaobanWxEnterpriseRelated.getEnterpriseId());
//					if(mainStore != null){
//						if(depart.getRelatedId().equals(mainStore.getStoreId())){
//							rList.add(staffDepartmentRelatedDTO);
//						}
//					}else{
//						rList.add(staffDepartmentRelatedDTO);
//					}
//				}
//			}
//			log.info("【部门list】rList={}",JSON.toJSONString(rList));
//			//DepartmentDTO departmentDTO =
//			String clerkCode = "";
//			if(!rList.isEmpty()){
//				for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : rList) {
//					clerkCode = staffDepartmentRelatedDTO.getClerkCode();
//					if(StringUtils.isNotBlank(clerkCode)){
//						break;
//					}
//				}
//			}
			String clerkCode = "";
			for (StaffClerkRelationDTO staffClerkRelationDTO : staffRelationList) {
				if(tabHaobanWxEnterpriseRelated.getEnterpriseId().equals(staffClerkRelationDTO.getEnterpriseId())){
					clerkCode = staffClerkRelationDTO.getClerkCode();
					break;
				}
			}
			
			ClerkDTO clerk = clerkService.getClerkByClerkCode(tabHaobanWxEnterpriseRelated.getEnterpriseId(), clerkCode);
			log.info("【新增外部联系人】clerkCode={}",clerkCode);
			if(clerk != null && StringUtils.isNotBlank(clerk.getQrcodeParam())){
				log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}",tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,name,avatar,clerk.getQrcodeParam());
				 member = memberOpenCardBusinessService.getMemberByQywxChannelParam(tabHaobanWxEnterpriseRelated.getEnterpriseId(),unionId,"",relaName,avatar,clerk.getQrcodeParam());
			}
			log.info("【新增外部联系人】member={},clerk={}",JSON.toJSONString(member),JSON.toJSONString(clerk));
			if(member != null){
				dto.setMemberId(member.getMemberId());
			}
			dto.setUnionid(unionId);
			
			dto.setExternalName(name);
			dto.setAddCreateTime(createTime);
			dto.setWxUserId(userId1);
			
			if(StringUtils.isBlank(unionId)){
				return "";
			}
			
			dto.setSuiteid(secretSetting.getSecretVal());
			
			MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(userId, tabHaobanWxEnterpriseRelated.getEnterpriseId(),name,createTime);
			String uuid = "";
			if(exsitDTO == null){
				dto.setUnionid(unionId);
				dto.setMemberId(dto.getMemberId());
				//更新对外联系人id
				dto.setSelfExternalUserid(selfExternalUserId);
				uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
			}else{
				return "";
			}
		}
		
		return "";
	}
	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		memberUnionRelatedService.delMemberUnionidRelated(dto);
		
	}

	private void getExternalUserUnionid(MemberUnionidRelatedDTO dto){
		TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(dto.getCorpid());
		if(wxEnterprise == null){
			return ;
		}
		SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterprise.getWxEnterpriseId(), SecretTypeEnum.CONTACT_CUSTOMER.getVal());
		if (null == secretSetting) {
			log.info("没有配置secret");
			return ;
		}
		String externalUseridInfo = this.qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), secretSetting.getSecretVal(), dto.getExternalUserid());
		if(StringUtils.isNotBlank(externalUseridInfo)){
			JSONObject jsonObject = JSON.parseObject(externalUseridInfo);
			dto.setUnionid(jsonObject.getString("unionid"));
		}
	}
	@Override
	public MemberUnionidRelatedDTO getByMemberId(String staffId, String memberId) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		log.info("【查询会员】wxUserId={},unionid={}",staff.getWxUserId(),memberId);
		return memberUnionRelatedService.getByMemberId(staff.getWxUserId(),memberId);
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
		List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId,wxEnterpriseId);
		return list;
	}
	@Override
	public List<MemberUnionidRelatedDTO> listByEnterpriseIdAndDate( String enterpriseId,Date date) {
		List<MemberUnionidRelated> list = memberUnionidRelatedMapper.listByEnterpriseIdAndDate(enterpriseId,date);
		return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class,list);
	}
	
	@Override
	public void freshWxFrend(String wxEnterpriseId, String wxUserId) {
		log.info("【刷下好友】wxUserId={}",wxUserId);
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting||secretSetting.getCheckFlag()==0) {
            log.info("没有配置客户联系secret:{}",wxEnterpriseId);
            return;
        }
        String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
		log.info("【刷下好友】res={}",res);
		if(StringUtils.isBlank(res)){
			return;
		}
		JSONArray jsonArr = JSON.parseArray(res);
		if(jsonArr.size() == 0) {
			return;
		}
		List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
		List<String> externalUserIdList = list.stream().map(student->student.getSelfExternalUserid())
				   .collect(Collectors.toList());
		for (Object object : jsonArr) {
			if(externalUserIdList.contains(object.toString())){
				continue;
			}else{
				//String string = qywxUserApiService.getCorpSelfExternalUseridInfo(enterprise.getCorpid(), enterprise.getWxSecretKey(), object.toString());
				this.add(wxEnterpriseId, object.toString(), wxUserId);
			}
		}
		
	}

	@Override
	public void cleanByCid(String cid) {
		if (StringUtils.isNotBlank(cid)) {
			TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(cid);
			if (null != wxEnterprise) {
				memberUnionRelatedService.clean(wxEnterprise.getWxEnterpriseId());
			}
		}else {
			memberUnionRelatedService.clean(null);
		}
	}
	@Override
	public Page<MemberUnionidRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		return  PageUtil.changePageHelperToCurrentPage(memberUnionRelatedService.pageMemberUnionByParams(userIdList,sendMemberIds,enterpriseId),MemberUnionidRelatedDTO.class);
	}
	
	@Override
	public String sendMessage(String wxEnterpriseId,String userId,List<String> extendUserList,String materialId){
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		MaterialDTO material = materialApiService.selectMaterialById(materialId);
		if(material == null){
			return "";
		}
		JSONResponse jp = null;
		if(material.getMaterialType() == 2 || material.getMaterialType() == 4 || material.getMaterialType() == 5){
			Date wxLastTime = material.getWxLastUploadTime();
			String maerialId = material.getMediaId();
			if(DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()){
				maerialId = materialApiService.reUpdalodMetail(materialId);
			}
			QywxImageExternalMessageDTO dto = new QywxImageExternalMessageDTO();
			dto.setMediaId(maerialId);
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}else if(material.getMaterialType() == 1){
			QywxTextExternalMessageDTO dto = new QywxTextExternalMessageDTO();
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			dto.setText(material.getMaterialContent());
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}else if(material.getMaterialType() == 3){
			QywxIinkExternalMessageDTO dto = new QywxIinkExternalMessageDTO();
			dto.setChatType("single");
			dto.setExternalUserid(extendUserList);
			dto.setSenderUserId(userId);
			dto.setDesc(material.getMaterialDesc());
			dto.setPicurl(material.getWxImgUrl());
			dto.setTitle(material.getMaterialTitle());
			dto.setUrl(material.getLink());
			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
		}
		log.info("【发送消息】jp = {}",JSON.toJSONString(jp));
		Map<String,Object> returnMap = jp.getReturnMap();
		return returnMap.get("msgid") == null?"":returnMap.get("msgid").toString();
	}
	@Override
	public JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId) {
		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
		if(enterprise == null){
			return null;
		}
		JSONResponse jp = qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId);
		return jp;
	}
	@Override
	public List<MemberUnionidRelatedDTO> getByWxUserIdListAndWxEnterpriseId(List<String> userIdList,
			String wxEnterpriseId) {
		return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, memberUnionidRelatedMapper.getByWxUserIdListAndWxEnterpriseId(userIdList,wxEnterpriseId));
	}
}
